#include "scene.h"
#include "triangle.h"

Scene *scene;

#include <iostream>

using namespace std;


Scene::Scene() {

  gui = new GUI();
  gui->show();

  int u0 = 20;
  int v0 = 50;
  int w = 320;
  int h = 240;
  fb = new FrameBuffer(u0, v0, w, h);

  fb->show();
  gui->uiw->position(fb->w+20+20, 50);

}

void Scene::DBG() {

  V3 verts[3] = {
    V3((float)fb->w/2.0f-10.0f, 13.0f, 0.0f),
    V3((float)17.0f, (float)fb->h/4.0f*3.0f, 0.0f),
    V3((float)fb->w-23.4, (float)fb->h/5.0f*4.0f, 0.0f)};
  Triangle tri;
  tri.verts[0] = verts[0];
  tri.verts[1] = verts[1];
  tri.verts[2] = verts[2];
  tri.color = V3(1.0f, 0.0f, 0.0f);
  tri.colors[0] = V3(1.0f, 0.0f, 0.0f);
  tri.colors[1] = V3(0.0f, 1.0f, 0.0f);
  tri.colors[2] = V3(0.0f, 0.0f, 1.0f);
//  tri.Rasterize(fb);
  tri.DrawWireFrame(fb);
  fb->redraw();
  return;

  fb->DrawCircle(120.4f, 103.4f, 50.0f, 0xFFFF0000);
  fb->redraw();
  return;

  fb->DrawCircle(120.4f, 103.4f, 50.0f, 0xFFFF0000);
  fb->DrawCircle(220.4f, 123.4f, 75.0f, 0xFF0000FF);
  FrameBuffer *edgeMap = fb->FindEdges();
  fb->redraw();
  edgeMap->position(fb->w+gui->uiw->w()+60, 50);
  edgeMap->show();
  return;


  V3 p0(14.1f, 20.2f, 0.0f);
  V3 p1(37.3f, 189.9f, 0.0f);
  fb->DrawSegment(p0, p1, 0xFF000000);
  fb->redraw();
  return;

  fb->DrawPoint(100, 200, 7, 0xFFFF0000);
  fb->redraw();
  return;

  int framesN = 1000;
  while (1) {
    for (int fi = 0; fi < framesN; fi++) {
      float currColorf = (float)fi/(float)(framesN-1);
      unsigned int currColor = 0xFF000000 + 
        (unsigned int) (255.0f*currColorf);
      fb->Set(currColor);
      fb->redraw();
      Fl::check();
    }
  }

}